// 前端未找到页面路由（固定不用改）
const notFoundRouter = {
  name: 'FourOhFour',
  path: '*',
  redirect: '/FourOhFour',
  hidden: true
}
const companyRouter = {
  name: 'index',
  path: '/',
  component: () => import('@/views/common/Base'),
  redirect: '/home',
  children: [{
      path: '/home',
      name: 'home',
      meta: {
        icon: 'icon-shouye',
        title: '首页'
      },
      component: () => import('@/views/page/Home'),
    },
    // {
    //   path: '/UserManagement',
    //   name: 'UserManagement',
    //   meta: {
    //     icon: 'icon-yonghuguanli',
    //     title: '用户管理'
    //   },
    //   component: () => import('@/views/system/UserManagement'),
    // },
    {
      path: '/interiorUserManagement',
      name: 'interiorUserManagement',
      meta: {
        icon: 'icon-yonghuguanli',
        title: '用户管理'
      },
      component: () => import('@/views/system/interiorUserManagement'),
    }, {
      path: '/CompanyManagement',
      name: 'CompanyManagement',
      meta: {
        icon: 'icon-gongsi',
        title: '公司管理'
      },
      component: () => import('@/views/system/CompanyManagement'),
    }
  ]
}
const clientRouter = {
  name: 'index',
  path: '/',
  component: () => import('@/views/common/Base'),
  redirect: '/MyWaybill',
  children: [{
    path: '/MyWaybill',
    name: 'MyWaybill',
    meta: {
      icon: 'icon-yundan',
      title: '我的运单'
    },
    component: () => import('@/views/system/MyWaybill'),
  }]
}
const userRouter = {
  path: '/UserManagement',
  name: 'UserManagement',
  meta: {
    icon: 'icon-yonghuguanli',
    title: '用户管理'
  },
  component: () => import('@/views/system/UserManagement'),
}
// 根级菜单
const rootRouter = {
  name: 'index',
  path: '/',
  component: () => import('@/views/common/Base'),
  redirect: '/home',
  children: [{
      path: '/home',
      name: 'home',
      meta: {
        icon: 'icon-shouye',
        title: '首页'
      },
      component: () => import('@/views/page/Home'),
    }, {
      path: '/addressBook',
      name: 'addressBook',
      meta: {
        icon: 'icon-cangku',
        title: '地址薄管理'
      },
      component: () => import('@/views/system/addressBook'),
    },
    {
      path: '/IceTracingManagement',
      name: 'IceTracingManagement',
      meta: {
        icon: 'icon-iceTracing',
        title: '冰排追溯管理'
      },
      component: () => import('@/views/IceCreamFreezer/IceTracingManagement'),
    }, {
      path: '/IceManagement',
      name: 'IceManagement',
      meta: {
        icon: 'icon-bingpaiguanli',
        title: '冰排管理'
      },
      component: () => import('@/views/IceCreamFreezer/IceManagement'),
    }, {
      path: '/FreezerManagement',
      name: 'FreezerManagement',
      meta: {
        icon: 'icon-binggui',
        title: '冷冻柜管理'
      },
      component: () => import('@/views/IceCreamFreezer/FreezerManagement'),
    }, {
      path: '/IncubatorManagement',
      name: 'IncubatorManagement',
      meta: {
        icon: 'icon-baowenxiangguanli',
        title: '保温箱管理'
      },
      component: () => import('@/views/system/IncubatorManagement'),
    }, {
      path: '/OrderManagement',
      name: 'OrderManagement',
      meta: {
        icon: 'icon-yundan',
        title: '订单管理'
      },
      component: () => import('@/views/OrderManagement/index'),
      redirect: '/OrderManagement/uncertainOrder',
      children: [{
        path: 'uncertainOrder',
        name: 'uncertainOrder',
        meta: {
          icon: 'icon-yueduye-mulu',
          title: '未确定订单'
        },
        component: () => import('@/views/OrderManagement/uncertainOrder.vue'),
      }, {
        path: 'reviewedOrder',
        name: 'reviewedOrder',
        meta: {
          icon: 'icon-daishenhe',
          title: '待审核订单'
        },
        component: () => import('@/views/OrderManagement/reviewedOrder.vue'),
      }, {
        path: 'pendingOrder',
        name: 'pendingOrder',
        meta: {
          icon: 'icon-daipeisong',
          title: '待配送订单'
        },
        component: () => import('@/views/OrderManagement/pendingOrder.vue'),
      }, {
        path: 'deliveryOrder',
        name: 'deliveryOrder',
        meta: {
          icon: 'icon-peisongzhong',
          title: '配送中订单'
        },
        component: () => import('@/views/OrderManagement/deliveryOrder.vue'),
      }, {
        path: 'completedOrder',
        name: 'completedOrder',
        meta: {
          icon: 'icon-yiwanchengdingdan',
          title: '已完成订单'
        },
        component: () => import('@/views/OrderManagement/completedOrder.vue'),
      }, {
        path: 'cancelledOrder',
        name: 'cancelledOrder',
        meta: {
          icon: 'icon-yiquxiaodingdan',
          title: '已取消订单'
        },
        component: () => import('@/views/OrderManagement/cancelledOrder.vue'),
      }, ]
    }, {
      path: '/WaybillManagement',
      name: 'WaybillManagement',
      meta: {
        icon: 'icon-yundanguanli',
        title: '运单管理'
      },
      component: () => import('@/views/system/WaybillManagement'),
    }
  ]
}

/**
 * 动态生成菜单
 * @param arrType
 * @returns {Promise<Router>}
 */
export const generatorDynamicRouter = arrType => {
  return new Promise((resolve, reject) => {
    const routers = []
    if (arrType.userType == "sys") {
      if (arrType.deptId === 0) {
        routers.push(notFoundRouter)
        routers.push(companyRouter)
      } else {
        function deleteObjectById(arr, name) {
          return arr.filter(obj => obj.name !== name);
        }
        rootRouter.children = deleteObjectById(rootRouter.children, 'CompanyManagement')
        routers.push(notFoundRouter)
        routers.push(rootRouter)
        if (arrType.type == 1) {
          rootRouter.children = deleteObjectById(rootRouter.children, 'UserManagement')
          rootRouter.children.splice(1, 0, userRouter)
        } else {
          rootRouter.children = deleteObjectById(rootRouter.children, 'UserManagement')
        }
      }
    } else {
      routers.push(notFoundRouter)
      routers.push(clientRouter)
    }
    resolve(routers)
  })
}
